classdef controlClass <  handle 
% Elmar, 11.02.07
% Elmar, 20.8.08

properties

%*********************
% output folders
%*********************

% export
expOutName@char      = 'unknown';
expOutName2@char      = 'unknown';
expOutFolder@char    = './';

% data objects
datSaveFolder@char   = './';


fromGlobCount = 1;
toGlobCount   = 1;
actGlobCount  = 1;

dataSetNum    = 1
%*********************
% export flags
%*********************
createVars = false;
saveSeqObj = true;
saveFigure = true;
saveJpg    = false;
saveTxt    = false;

collecting = false;

%*********************
% handles
%*********************
hfigure = [];
haxes   = [];

%*********************
% objects
%*********************
seqObj     = {};
fList      = {};
netObj     = [];

end


methods

%*********************
% Constructor
%*********************
function obj = controlClass(name)
    obj.expOutName = name;
    obj.fList = fitListClasses;
end
function obj = initObject(obj)
    obj.fList      = fitListClasses;
    obj.expOutName = datestr(now,'dd.mm.yyyy');
    obj.fList = fitListClasses;
    
    % init sequence objects
    obj.seqObj{1} = sequenceClass;
    obj.seqObj{1}.numSeq = 1;    
    obj.seqObj{2} = sequenceClass;
    obj.seqObj{2}.numSeq = 2;    
end
% start network
function obj = initNetwork(obj)
    obj.netObj = networkClass;
    obj.netObj.initUdp;
    obj.netObj.openUdp;
end
function obj = initGUI(obj,nScreens)
    % main
    hObject = gui_seqmain(nScreens);
    set(hObject,'visible','off');    
    drawnow;

    % seqObj1
    hSeq1 = gui_sequence(1);
    obj.seqObj{1}.hGUI = hSeq1;    
    t1 = uisubgui( hSeq1.figure1, hObject, [0.0,0.51],'hSeq1');
    close(hSeq1.output);
    % seqObj2
    hSeq2 = gui_sequence(2);
    obj.seqObj{2}.hGUI = hSeq2;    
    %t2 = uisubgui( hSeq2.figure1, hObject, [0.0,0.03],'hSeq2');
    t2 = uisubgui( hSeq2.figure1, hObject, [0.0,0.01],'hSeq2');
    close(hSeq2.output);
    set( obj.seqObj{2}.hGUI.rb_network, 'enable','off');
    
    drawnow;
    pos = get(hObject,'position');
    if nScreens==2
         pos(1) = 5+1280;
    else
         pos(1) = 5;
    end
    pos(2) = 5;
    set(hObject,'visible','on');  
    drawnow;
    set(hObject,'position',pos);
    drawnow;
    
end



function obj = makeFigure(obj,num)

    sObj = obj.seqObj{num};
    
    % create figure
    obj.hfigure = figure;
    obj.haxes   = axes('parent',obj.hfigure);
    
    pos = get(obj.hfigure,'Position');
    pos = [ pos(1)/2,150,pos(3)*1,pos(4)*1];
    set(obj.hfigure, 'Position', pos');
    set(obj.hfigure, 'Name',     obj.expOutName);
    set(obj.hfigure, 'Units',    'normalized');
    
    % fix toolbar    
    htoolbar = findall(obj.hfigure,'Tag','FigureToolBar');
    uipushtool(htoolbar,'Separator','on','enable','off'); % Abstandshalter
    uipushtool(htoolbar,'CData',imread('export.png'),...
            'TooltipString','Export Data','Separator','on','ClickedCallback',...
            ['gui_control(',num2str(num),');']);        
    
    sObj.updatePlot(obj.haxes);  
    sObj.updatePlotFits(obj.haxes,0);  
    title(obj.expOutName);
    plotedit(obj.hfigure);    
    
end


function obj = collectData(obj, hlist, num)

    obj.collecting = true;
    for i=obj.fromGlobCount:1:obj.toGlobCount
        if ~obj.collecting
            break;
        end
        try
            set(hlist,'string',num2str(i));
        end
        fname = [obj.datSaveFolder,'\',num2str(i),'_calculated.mat'];
        if exist(fname,'file')
            load(fname,'controlParameters','calcParameters');
             if exist('controlParameters','var') && exist('calcParameters','var')
                obj.seqObj{num} = obj.seqObj{num}.updateParameters(0,controlParameters,calcParameters);
             end
        else
            disp(['Could not find file ',fname]);
        end
        drawnow;
    end
    obj.collecting = false;
    
end

function obj = updateParameters(obj,controlParameters,calcParameters)
    if obj.seqObj{1}.doUpdate
        obj.seqObj{1} = obj.seqObj{1}.updateParameters(0,controlParameters,calcParameters);
    end
    if obj.seqObj{2}.doUpdate
        obj.seqObj{2} = obj.seqObj{2}.updateParameters(0,controlParameters,calcParameters);
    end
end


end
end
