function saveDataSet(obj, num)


    seqObj = obj.seqObj{num};
    
    if isempty(obj.hfigure) ||  isempty(obj.haxes)
        disp('figure handle is empty.');
        return;
    end
    
    
    
    % save figure and jpg
    name =  [obj.expOutFolder,'\',obj.expOutName,'.fig'];
    saveas(obj.hfigure, name,'fig');      

    if obj.saveJpg
        name =  [obj.expOutFolder,'\',obj.expOutName,'.png'];
        saveas(obj.hfigure, name,'png');
    end
     
    if obj.saveSeqObj
       name =  [obj.expOutFolder,'\',obj.expOutName,'.mat'];
       save(name, 'seqObj');         
    end
     
     
     % save data to textfile
     if obj.saveTxt
        for i=1:4
            if obj.seqObj{num}.listData{i}.numRawPoints > 0
                f1 = [obj.expOutFolder,'/',obj.expOutName,'_data',num2str(i),'.txt'];
                fid = fopen(f1, 'wt');
                    fprintf(fid, '%%%s\n',datestr(now,'HH:MM:SS  dd.mm.yyyy'));
                    fprintf(fid, '%%%s\n',obj.seqObj{num}.listData{i}.xName);
                    fprintf(fid, '%%%s\n',obj.seqObj{num}.listData{i}.yName);
                    fprintf(fid, '%% globalcount    x_value      y_value      selected\n');
                fclose(fid);
                dd = obj.seqObj{num}.listData{i}.rawData;
                save(f1, 'dd' ,'-ascii','-append');         
            end
        end
     end
    
    
    if obj.createVars 
        for i=1:4  
            ddx = ['data',num2str(i),'_x'];
            ddy = ['data',num2str(i),'_y'];         
            if exist(ddx,'var')
                ddx = [];
            end
            if exist(ddy,'var')
                ddy = [];
            end
            if obj.seqObj{num}.listData{i}.numSelPoints > 0
                assignin('base',ddx,obj.seqObj{num}.listData{i}.selectedData(:,2));
                assignin('base',ddy,obj.seqObj{num}.listData{i}.selectedData(:,3));            
            end
        end
    end

end