function updatePlotFits(obj, hax, mode)

    if ~exist('hax','var')
        h_axes = obj.hGUI.plotAxes;
    else
        h_axes = hax;
    end
    
    if ~exist('mode','var')
        mode = 1;
    end
    

    % get axes size
    x1  = xlim(h_axes);
    y1  = ylim(h_axes);
    dx1 = abs(x1(1)-x1(2));
    dy1 = abs(y1(1)-y1(2));
    
    % cycle fits
    hold(h_axes,'on');    
    for i=1:obj.numFits
        if obj.listFits{i}.showFit
            obj.listFits{i}.plotFit(h_axes);            
        end
        if mode && obj.listFits{i}.doFit && obj.listFits{i}.doPreSetting
             watchPrePoints(h_axes,obj.numSeq,i,obj.listFits{i}.plotColor);
        end
    end

    % fix axes size
    delx2 = xlim(h_axes);
    dely2 = ylim(h_axes);

    hold(h_axes,'off');
end