function  y = dsawtooth( t, t_all, t_up, offs, ampl, dt, tau)
%SAWTOOTH calculates sawtooth function damped
% with parameters 
% y = vsawtooth( t, t_all, t_up, offs, ampl)
%
%      / \                 ^
%     /   \                |
%    /     \    --- offs   |
%   /       \              |  ampl  
%  /         \             |  
%        t_down             
% <-- t_all -->
% Elmar, 4.8.2007 


t_cut = mod(t-dt,t_all);
flag  = (t_cut>t_up);

y = ampl * exp(-t/tau).*(~flag .* t_cut/t_up + flag.*(t_all-t_cut)/abs(t_all-t_up) -0.5 )+offs;

