function varargout = gui_control(varargin)
%GUI_CONTROL interface for gui_sequence.m to load
% data from mat files
%
% 22.7.07 Elmar,

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_control_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_control_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
end


%******************************
% opening function
%******************************
function gui_control_OpeningFcn(hObject, eventdata, handles, num)
global controlObj;

    handles.output = hObject;
    if exist('num','var')
        handles.number = num;
    else
        handles.number = 1;
    end
    guidata(hObject, handles);
    set(gcf,'name','export');
    

    if ~isempty(controlObj.haxes) && ishandle(controlObj.haxes )
        ft = get(get(controlObj.haxes,'title'),'String');
        if iscell(ft)
                fTitle = ft{1};
        else
                fTitle = ft;
        end
        if ~isempty(fTitle)
            controlObj.expOutName = fTitle;
        end
    end    
   
    %************
    % init gui
    %************    
    set(handles.txt_name,       'String', num2str(controlObj.expOutName));
    set(handles.txt_foldername, 'String', num2str(controlObj.expOutFolder));
    set(handles.rb_mat,         'value',  controlObj.saveSeqObj);
    set(handles.rb_fig,         'value',  controlObj.saveFigure);
    set(handles.rb_pic,         'value',  controlObj.saveJpg);
    set(handles.rb_vars,        'value',  controlObj.createVars);
    set(handles.rb_txt,        'value',  controlObj.saveTxt);

    set(handles.txt_datasetnum,     'string', num2str(controlObj.dataSetNum));
    set(handles.txt_foldernameSave, 'string', num2str(controlObj.expOutName2));    

    set(handles.txt_loadPicFolder, 'string', num2str(controlObj.datSaveFolder));    
    set(handles.txt_from,          'string', num2str(controlObj.fromGlobCount));    
    set(handles.txt_to,            'string', num2str(controlObj.toGlobCount));    
    
    drawnow;
    uiwait(hObject);
end
function gui_control_OutputFcn(hObject, eventdata, handles) 
    if ~isempty(handles) && ishandle(handles.output)
        delete(handles.output);
    end
    drawnow;
end


function get_savedata(handles)
global controlObj;
    controlObj.saveSeqObj = get(handles.rb_mat, 'value');
    controlObj.saveFigure = get(handles.rb_fig, 'value');
    controlObj.saveJpg    = get(handles.rb_pic, 'value');
    controlObj.createVars = get(handles.rb_vars,'value');
    controlObj.saveTxt    = get(handles.rb_txt,'value');
    
    
    controlObj.dataSetNum    = get(handles.txt_datasetnum,'string');
    controlObj.expOutName    = get(handles.txt_name,       'String');
    controlObj.fromGlobCount = str2num(get(handles.txt_from,      'string'));
    controlObj.toGlobCount   = str2num(get(handles.txt_to,        'string'));
end
function pb_save_Callback(hObject, eventdata, handles)
global controlObj;
    get_savedata(handles);
    controlObj.saveDataSet(handles.number);
    uiresume(handles.output);    
end


%<------------------------- callbacks ------------------------------>

% save folder
function txt_foldername_Callback(hObject, eventdata, handles, num)
global controlObj;
    folder = get(hObject,'String');
    if ~ischar(folder) || ~exist(folder,'dir');
        str = {['The folder "',folder,'" does not exist.'], ... % make folder ?
                ' Do you want to create it?'};
        button = questdlg(str,'file-error','yes','no','yes');
        if strcmp( button , 'yes')
            try
                mkdir(folder);
                disp(['Created folder ',folder,'.']); 
            catch
                msgstr = lasterr;
                str = {['Could not creat folder "',folder,'".'],'',msgstr};
                warndlg(str,'file-error'); 
                folder = './';
            end
        end
    end
    switch num
        case 1
            controlObj.expOutFolder = folder;
        case {2,3}
            controlObj.datSaveFolder = folder;
    end
end
% browse folder
function pb_browsefolder_Callback(hObject, eventdata, handles, num )
global controlObj;
    switch num
        case {1,2} 
            oldfolder = controlObj.expOutFolder;
        case 3
            oldfolder = controlObj.datSaveFolder;
    end
    
    if ischar(oldfolder) && exist(oldfolder);           % get user selection
        newfolder = uigetdir(oldfolder);                % start in old dir
    else
        newfolder = uigetdir();                         % start in base dir
    end;
    if ~newfolder
        return;
    end;
    switch num
        case {1,2}        
            set(handles.txt_foldername,'String',newfolder);
            controlObj.expOutFolder = newfolder;
        case 3
            set(handles.txt_foldernameSave,'String',newfolder);
            set(handles.txt_loadPicFolder,'String',newfolder);
            controlObj.datSaveFolder = newfolder;
    end
end
function pb_browsename_Callback(hObject, eventdata, handles, num )
global controlObj;

    switch num
        case 2
        if ischar(controlObj.expOutName2) && exist(controlObj.expOutName2,'file')
            [pathstr, name, ext, versn] = fileparts(controlObj.expOutName2);
            folder = pathstr;
        else
            folder = './';
        end
        case 1
        if ischar(controlObj.expOutFolder) && exist(controlObj.expOutFolder,'dir');       
            folder = controlObj.expOutFolder;        % start in old dir
        else
            folder = './';                            % start in base dir
        end;
    end

    [filename, pathname] = uigetfile({'*.mat';'*.txt'},'load',[folder,'\*.mat']);
    if ischar(pathname) && exist([pathname,filename],'file')
        switch num
            case 1        
                set(handles.txt_name,'String',filename);
                controlObj.expOutName   = filename;
                controlObj.expOutFolder = pathname;
                set(handles.txt_foldername,'String',pathname);
            case 2
                set(handles.txt_foldernameSave,'String',[pathname,filename]);
                controlObj.expOutName2   = [pathname,filename];
        end
    end
end

function pb_closeall_Callback(hObject, eventdata, handles)
    get_savedata(handles);
    uiresume(handles.output);
end


function txt_fromto_Callback(hObject, eventdata, handles, selection)
global controlObj;
    numstr = get(hObject,'string');
    try
        num = str2num(numstr);
    catch
        warndlg(['Could not convert to number: ',numstr]);
        return;
    end
    
    switch selection
        case 1  % from
            controlObj.fromGlobCount = num;
        case 2
            controlObj.toGlobCount = num;
        case 3
            controlObj.dataSetNum = num;
    end
end


function pb_loaddataset_Callback(hObject, eventdata, handles)
global controlObj;
%try 
    pb_closeall_Callback(0, eventdata, handles);
    drawnow;
    controlObj = controlObj.loadDataSets(handles.number);
%catch
%    disp(lasterr);
%end
end


function pb_ok_Callback(hObject, eventdata, handles)
global controlObj;
    controlObj = controlObj.collectData(handles.txt_current,handles.number);
end
function pb_stop_Callback(hObject, eventdata, handles)
global controlObj;
    controlObj.collecting = false;
end


