function h_group = gui_plotMenu(h_axes, seq)
%PLOTMENU provides small pulldown menu inside the plot. It is used for 
% mouse selection of the points
global controlObj;


%*************************************
% check arguments and get handles
%*************************************
fig = ancestor(h_axes, 'figure', 'toplevel');


%*************************
% create menu
%*************************
cmenu = uicontextmenu('Parent',fig);
set(h_axes, 'UIContextMenu', cmenu, 'Interruptible', 'off');

uimenu(cmenu, ...
    'Label',    'Remove Points', ...
    'Callback',  @removePoints ,...
    'Interruptible','off', ...
    'BusyAction','queue' ...
);


    %***************************
    % Start removing points
    %***************************
    function removePoints(varargin)
        rect = getrect(h_axes);
        drawnow;
        if sum(rect(3:4)==0)
            return;
        end;
    
        xmin = rect(1);
        xmax = rect(1)+rect(3);
        ymin = rect(2);
        ymax = rect(2)+rect(4);
    
        controlObj.seqObj{seq} = controlObj.seqObj{seq}.removePoints(xmin,xmax,ymin,ymax);
        controlObj.seqObj{seq} = controlObj.seqObj{seq}.updateFits(0);            
        controlObj.seqObj{seq}.updatePlot;
        controlObj.seqObj{seq}.updatePlotFits;
    end

    %***************************
    % set data cursormode
    % noch fixen
    %***************************
    %function dataCursor(varargin)
    %    if varargin{3}
    %        datacursormode on;
    %        set(h_axes, 'UIContextMenu', cmenu);
    %    else
    %        datacursormode off;
    %        set(h_axes, 'UIContextMenu', cmenu);            
    %    end
    %end

end
