function varargout = gui_seq_main(varargin)
%GUI_SEQ_MAIN main canvas for other widgets,
% 
% This is only the canvas for all the other widgets. Each gui widgets is
% created on its own (to keep debugging simple) and than copied with
% uisubgui to the main figure.
%
% Elmar, Innsbruck 31.03.07

    gui_Singleton = 1;
    gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_seq_main_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_seq_main_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
    if nargin && ischar(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
    end

    if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
    else
        gui_mainfcn(gui_State, varargin{:});
    end
end



%%%%%%%%%%%%%%%%%%%%%%%%
% opening
%%%%%%%%%%%%%%%%%%%%%%%%
function gui_seq_main_OpeningFcn(hObject, eventdata, handles, nScreens )
    
    handles.output = hObject;
    guidata(hObject, handles);
    hseqmain = handles.output;
    set(hObject, 'CloseRequestFcn', {@saveAndClose});   
    
     % fix look
    set(hseqmain, 'toolbar', 'none');
    set(hseqmain, 'menubar', 'none');
    set(hseqmain, 'numbertitle','off');
%    MGCHANGE: Don't set the size to full screen - the GUI looks weird otherwise
%    geom = get(0, 'screensize');
%    set(hseqmain, 'outerPosition',geom);
    set(hseqmain, 'visible','on');
end


%**********************************
% return function
%**********************************
function varargout = gui_seq_main_OutputFcn(hObject, eventdata, handles) 
    varargout{1} = handles.output;
end



%********************************
% tidy up network and flags
%********************************
function saveAndClose(hObject,event)
global controlObj;
    % network
    try
        controlObj.netObj.closeUdp;
        controlObj.netObj.clearUdp;
    catch
        disp(lasterr);
    end
    if isdeployed
        save('./saved/controlObj.mat','controlObj');
    else
        save('./saved/controlObj.mat','controlObj');
    end
    delete(hObject);
end




