function varargout = gui_sequence(varargin)
%GUI_SEQUENCE provides one block of datasets and fits for
% the sequence program. This block is used to access seqObj1
%
% Elmar, 31.03.07
% changed 8.808, Elmar
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_sequence_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_sequence_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end
if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
end


%*************************************************************************
%
% Init stuff
%
%*************************************************************************

%**************
% opening
%**************
function gui_sequence_OpeningFcn(hObject, eventdata, handles, num)
global controlObj;

    % set global variables
    handles.output  = hObject;
    handles.number  = num;
    guidata(hObject, handles);

    % set gui properties
    udateGUIDataFirst(handles, {'...','...','...','...'}, {'...','...','...','...'}, 1:controlObj.seqObj{num}.numData);
    updateGUIFitsFirst(handles, 1:controlObj.seqObj{num}.numData);
    gui_plotMenu(handles.plotAxes, num);
    %set(hObject, 'CloseRequestFcn', {@saveAndClose});   
end
function varargout = gui_sequence_OutputFcn(hObject, eventdata, handles) 
    varargout{1} = handles;
end
 

%*************************************************************************
%
% Callbacks for datasets
%
%*************************************************************************

% Update total block?
function rb_doUpdate_Callback(hObject, eventdata, handles)
global controlObj;
    controlObj.seqObj{handles.number}.doUpdate = logical(get(hObject,'Value') );
end

%*************************
% activate dataset
%*************************
function pb_active_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listData{num}.doUpdate = logical(get(hObject,'Value'));
    
    if controlObj.seqObj{handles.number}.listData{num}.doUpdate
        controlObj.seqObj{handles.number}.updateParameters(1);          % activate

        % MGCHANGE: bugfix
%        strX = get(handles.lb_paramX1,'String');        % get list selection
%        strY = get(handles.lb_paramY1,'String');
        eval(['strX = get(handles.lb_paramX',num2str(num),',''String'');']);
        eval(['strY = get(handles.lb_paramY',num2str(num),',''String'');']);
        eval(['numX = get(handles.lb_paramX',num2str(num),',''Value'');']);
        eval(['numY = get(handles.lb_paramY',num2str(num),',''Value'');']);                
        controlObj.seqObj{handles.number}.listData{num}.xName = strX{numX};       % get name
        controlObj.seqObj{handles.number}.listData{num}.yName = strY{numY};
        controlObj.seqObj{handles.number}.updatePlot;
        controlObj.seqObj{handles.number}.updatePlotFits;              
    end
end
%************************
% mean
%************************
function pb_mean_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listData{num}.doAverage = logical(get(hObject,'Value'));
    controlObj.seqObj{handles.number} = controlObj.seqObj{handles.number}.updateData(num);
    controlObj.seqObj{handles.number}.updatePlot;
    controlObj.seqObj{handles.number}.updatePlotFits;        
end

% show
function pb_show_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listData{num}.showDataPoints = logical(get(hObject,'Value'));
    controlObj.seqObj{handles.number}.updatePlot;
    controlObj.seqObj{handles.number}.updatePlotFits;    
end

% clear dataset
function pb_clear_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
    set(handles.plotAxes,'XLimMode','auto');
    set(handles.plotAxes,'YLimMode','auto');     
    controlObj.seqObj{handles.number}.updatePlot;    
    controlObj.seqObj{handles.number}.updatePlotFits;        
end

% edit
function pb_edit_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.editObject;
    updateGUIData(handles,num);
    controlObj.seqObj{handles.number} = controlObj.seqObj{handles.number}.updateData(num);    
    controlObj.seqObj{handles.number}.updatePlot;
    controlObj.seqObj{handles.number}.updatePlotFits;
end

% update widgets for dataset
function updateGUIData(handles, list)
global controlObj;
    for num=list
        nStr = num2str(num);
        eval(['set(handles.pb_active',nStr,',''Value'',controlObj.seqObj{handles.number}.listData{',nStr,'}.doUpdate);']);
        eval(['set(handles.pb_edit',  nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listData{',nStr,'}.plotColor);']);
        eval(['set(handles.pb_mean',  nStr,',''Value'',controlObj.seqObj{handles.number}.listData{',nStr,'}.doAverage);']);
        eval(['set(handles.pb_show',  nStr,',''Value'',controlObj.seqObj{handles.number}.listData{',nStr,'}.showDataPoints);']);

        eval(['set(handles.pb_edit',  nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listData{',nStr,'}.plotColor);']);
        eval(['set(handles.lb_paramX',nStr,',''BackgroundColor'',min([1,1,1],controlObj.seqObj{handles.number}.listData{',nStr,'}.plotColor + [.85,.85,.85]));']);
        eval(['set(handles.lb_paramY',nStr,',''BackgroundColor'',min([1,1,1],controlObj.seqObj{handles.number}.listData{',nStr,'}.plotColor + [.85,.85,.85]));']);
        eval(['set(handles.pb_active',nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listData{',nStr,'}.plotColor);']);
        eval(['set(handles.pb_show',  nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listData{',nStr,'}.plotColor);']);
        eval(['set(handles.pb_mean',  nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listData{',nStr,'}.plotColor);']);
        eval(['set(handles.pb_clear', nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listData{',nStr,'}.plotColor);']);            
    end
end
% update widgets for first time
function udateGUIDataFirst(handles,XString,YString,list)
global controlObj;
    updateGUIData(handles,list);
    for num=list
        nStr = num2str(num);
        eval(['set(handles.lb_paramX',nStr,',''Value'',1);']);
        eval(['set(handles.lb_paramX',nStr,',''String'',XString(',nStr,'));']);
        eval(['set(handles.lb_paramY',nStr,',''Value'',1);']);            
        eval(['set(handles.lb_paramY',nStr,',''String'',YString(',nStr,'));']);
    end
    set(handles.rb_network,'Value' ,controlObj.seqObj{handles.number}.doUpdate);
    set(handles.pb_logx,  'value'  ,controlObj.seqObj{handles.number}.logx);
    set(handles.pb_logy,  'value'  ,controlObj.seqObj{handles.number}.logy);
end


%****************************
% take parameterlist for X
%****************************
function pb_paramX_Callback(hObject, eventdata, handles, num)
global controlObj;

    % get parameter list, change to cell is needed
    eval(['strX = get(handles.lb_paramX',num2str(num),',''string'');']);
    if ischar(strX)
        strX = {strX};
    end
    % get Name
    oldXName = controlObj.seqObj{handles.number}.listData{num}.xName;
    eval(['numX = get(handles.lb_paramX',num2str(num),',''Value'');']);
    if numX <= length(strX)
        controlObj.seqObj{handles.number}.listData{num}.xName = strX{numX};
    else
        controlObj.seqObj{handles.number}.listData{num}.xName = '';
    end
    % clear data if name has changed
    if ~strcmp(oldXName, controlObj.seqObj{handles.number}.listData{num}.xName )
        if controlObj.seqObj{handles.number}.listData{num}.numRawPoints == 0 
            controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
        elseif strcmp( questdlg('Do you realy want to clear this dataset?','gui','yes','no','yes'), 'yes')
        	controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
            
        end
    end
    set( hObject, 'Backgroundcolor', min([1,1,1], controlObj.seqObj{handles.number}.listData{num}.plotColor + [.85,.85,.85])); 
    controlObj.seqObj{handles.number}.updatePlot;
    controlObj.seqObj{handles.number}.updatePlotFits;    
end

%****************************
% take parameterlist for Y
%****************************
function pb_paramY_Callback(hObject, eventdata, handles, num)
global controlObj;

    % get new values
    eval(['strY = get(handles.lb_paramY',num2str(num),',''string'');']);    
    if ischar(strY)
        strY = {strY};
    end
    % get Name 
    oldYName = controlObj.seqObj{handles.number}.listData{num}.yName;
    eval(['numY = get(handles.lb_paramY',num2str(num),',''Value'');']);
    if numY <= size(strY,1)
        controlObj.seqObj{handles.number}.listData{num}.yName = strY{numY};
    else
        controlObj.seqObj{handles.number}.listData{num}.yName = '';
    end
    % clear data if name has changed
    if ~strcmp(oldYName,controlObj.seqObj{handles.number}.listData{num}.yName)
        if controlObj.seqObj{handles.number}.listData{num}.numRawPoints == 0 
            controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
        elseif strcmp( questdlg('Do you realy want to clear this dataset?','gui','yes','no','yes'), 'yes')
            controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
        end
    end
    set( hObject, 'Backgroundcolor', min([1,1,1], controlObj.seqObj{handles.number}.listData{num}.plotColor + [.85,.85,.85]));        
    controlObj.seqObj{handles.number}.updatePlot;
    controlObj.seqObj{handles.number}.updatePlotFits;    
end




function lb_paramX_ButtonDownFcn(hObject, eventdata, handles, num)
global controlObj;

    if num == 1 
        return;
    end
    % get new values
    strX = get(handles.lb_paramX1,'string');
    numX = get(handles.lb_paramX1,'value');
    
    % get/set values to num
    set(hObject,'String',strX);
    set(hObject,'value',numX);
    oldXName = controlObj.seqObj{handles.number}.listData{num}.xName;    
    controlObj.seqObj{handles.number}.listData{num}.xName = strX{numX};

    % check if name has changed
    if ~strcmp(oldXName, controlObj.seqObj{handles.number}.listData{num}.xName )
        if controlObj.seqObj{handles.number}.listData{num}.numRawPoints == 0 
            controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
        elseif strcmp( questdlg('Do you realy want to clear this dataset?','gui','yes','no','yes'), 'yes')
        	controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
        else
            return;
        end
    end
    set( hObject, 'Backgroundcolor', min([1,1,1], controlObj.seqObj{handles.number}.listData{num}.plotColor + [.85,.85,.85]));               
    controlObj.seqObj{handles.number}.updatePlot;
   
end

function lb_paramY_ButtonDownFcn(hObject, eventdata, handles, num)
global controlObj;

    if num == 1 
        return;
    end
    % get new values
    strY = get(handles.lb_paramY1,'string');
    numY = get(handles.lb_paramY1,'value');
    
    % get/set values to num
    set(hObject,'String',strY);
    set(hObject,'value',numY);
    oldYName = controlObj.seqObj{handles.number}.listData{num}.yName;    
    controlObj.seqObj{handles.number}.listData{num}.yName = strY{numY};

    % check if name has changed
    if ~strcmp(oldYName, controlObj.seqObj{handles.number}.listData{num}.yName )
        if controlObj.seqObj{handles.number}.listData{num}.numRawPoints == 0 
            controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
        elseif strcmp( questdlg('Do you realy want to clear this dataset?','gui','yes','no','yes'), 'yes')
        	controlObj.seqObj{handles.number}.listData{num} = controlObj.seqObj{handles.number}.listData{num}.reset;
        else
            return;
        end
    end
    set( hObject, 'Backgroundcolor', min([1,1,1], controlObj.seqObj{handles.number}.listData{num}.plotColor + [.85,.85,.85]));               
    controlObj.seqObj{handles.number}.updatePlot;
   
end

%*************************************************************************
%
% Callbacks for plotting
%
%*************************************************************************

%****************
% redraw all
%****************
function pb_redraw_Callback(hObject, eventdata, handles)
global controlObj;
    controlObj.seqObj{handles.number} = controlObj.seqObj{handles.number}.updateData;
    controlObj.seqObj{handles.number} = controlObj.seqObj{handles.number}.updateFits(0);
    controlObj.seqObj{handles.number}.updatePlot;
    controlObj.seqObj{handles.number}.updatePlotFits;
    controlObj.seqObj{handles.number}.updateFitResults;
end
      
%*********************************
% edit plot, 
% Achsen einzeln bearbeiten
%*********************************
function pb_editplot_Callback(hObject, eventdata, handles)
    
    %************************
    % alte position holen
    %************************
    pfig       = get(handles.base,'parent');
    posFigOld  = get(pfig,'position');
    posAxes    = get(handles.plotAxes,'position');
    hleg       = legend(handles.plotAxes);
    
    %*************************************
    % neues Fenster ffnen fullscreen
    %*************************************
    h1 = figure;
    set(h1,'numbertitle','off');
    if posFigOld(1) > 1200
        pos = get(0,'screensize') + [1280,0,0,0];
    else
        pos = get(0,'screensize');
    end
    set(h1,'OuterPosition',pos);
    set(pfig,'Visible','off');
    set(h1,'CloseRequestFcn',{@closeEditPlot,h1,pfig,posAxes,posFigOld,handles});

    %*************************************
    % achse rberziehen
    %*************************************
    set(handles.plotAxes,'parent',h1);
    set(handles.plotAxes,'units','normalized');
    set(handles.plotAxes,'position',[0.1,0.1,0.85,0.85]);
    propedit(handles.plotAxes,'on')
    set(hleg,'parent',h1);
end

function closeEditPlot(hObject, event, hFigure, pfig, pos, posFigOld,handles)
global controlObj;
    plotedit(handles.plotAxes,'off')
    set(handles.plotAxes,'units','pixel');
    set(handles.plotAxes,'Parent',handles.base);
    set(handles.plotAxes,'position',pos);
    hleg = legend(handles.plotAxes);    
    set(hleg,'parent',pfig);    
    set(pfig,'Visible','on');    
    delete(hFigure);
    %set(get(handles.plotAxes,'parent'),'position',posFigOld);
    controlObj.seqObj{handles.number}.updatePlot;
    controlObj.seqObj{handles.number}.updatePlotFits;
end

%***************************
% scale log
%***************************
function pb_log_Callback(hObject, eventdata, handles, mode)
global controlObj;
    value = get(hObject,'value');
    switch mode
        case 1
            controlObj.seqObj{handles.number}.logx = value;
        case 2
            controlObj.seqObj{handles.number}.logy = value;
    end
    controlObj.seqObj{handles.number}.updatePlot;
    controlObj.seqObj{handles.number}.updatePlotFits;
end






%***********************************************************************
%
% Callbacks for fits
%
%***********************************************************************


% update widgets for fits
function updateGUIFits(handles, list)
global controlObj;

    % select fitnumber
    numFits = size(controlObj.fList.names,2);
    for i=list
        nStr = num2str(i);

        % fit listbox selection
        selNum = min(numFits,controlObj.seqObj{handles.number}.listFits{i}.fitNumber);
        eval(['set(handles.lb_fit',      nStr,',''value'',',num2str(selNum),');']);
        eval(['set(handles.pb_fitA',     nStr,',''Value'',controlObj.seqObj{handles.number}.listFits{',nStr,'}.doFit);']);            
        eval(['set(handles.pb_fitshow',  nStr,',''Value'',controlObj.seqObj{handles.number}.listFits{',nStr,'}.showFit);']);            
        eval(['set(handles.pb_fitsAdopt',nStr,',''Value'',controlObj.seqObj{handles.number}.listFits{',nStr,'}.adoptPoints);']);     
        
        eval(['set(handles.lb_fit',      nStr,',''BackgroundColor'',min([1,1,1],controlObj.seqObj{handles.number}.listFits{',nStr,'}.plotColor + [.85,.85,.85]));']);            
        eval(['set(handles.pb_Fit',      nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listFits{',nStr,'}.plotColor);']);
        eval(['set(handles.pb_fitA',     nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listFits{',nStr,'}.plotColor);']);
        eval(['set(handles.pb_fitC',      nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listFits{',nStr,'}.plotColor);']);   
        eval(['set(handles.pb_fitshow',   nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listFits{',nStr,'}.plotColor);']);   
        eval(['set(handles.pb_fitsAdopt', nStr,',''ForegroundColor'',controlObj.seqObj{handles.number}.listFits{',nStr,'}.plotColor);']);   
    end
end
% initiate widgets for fits first time
function updateGUIFitsFirst(handles, list)
global controlObj;

   updateGUIFits(handles, list);
   for i=list
       nStr = num2str(i);
       eval(['set(handles.lb_fit',   nStr,',''String'',controlObj.fList.names);']);
       eval(['set(handles.lb_fit',   nStr,',''value'',1);']);
   end
end

%*************************
% change fit selection
%*************************
function lb_fit_Callback(hObject, eventdata, handles, num)
global controlObj;

    fNumber = get(hObject,'Value');
    doFit   = controlObj.seqObj{handles.number}.listFits{num}.doFit;
    fColor  = controlObj.seqObj{handles.number}.listFits{num}.plotColor;
    fDataSet= controlObj.seqObj{handles.number}.listFits{num}.dataSet;

    if ~isa(controlObj.fList.fClass{fNumber}, 'function_handle')
        disp('Fit selection is not possible.');
        return;
    end
    
    
    % changed fit object?
    if fNumber ~= controlObj.seqObj{handles.number}.listFits{num}.fitNumber  
        controlObj.seqObj{handles.number}.listFits{num} = controlObj.seqObj{handles.number}.listFits{num}.clearFit(handles.plotAxes);
        controlObj.seqObj{handles.number}.listFits{num} = feval( controlObj.fList.fClass{fNumber} );

        % set parameters
        controlObj.seqObj{handles.number}.listFits{num}.fitNumber = fNumber;
        controlObj.seqObj{handles.number}.listFits{num}.dataSet   = fDataSet;
        controlObj.seqObj{handles.number}.listFits{num}.doFit     = doFit;
        controlObj.seqObj{handles.number}.listFits{num}.plotColor = fColor;
        controlObj.seqObj{handles.number}.listFits{num} = controlObj.seqObj{handles.number}.listFits{num}.initFitting;
        controlObj.seqObj{handles.number}.listFits{num} = controlObj.seqObj{handles.number}.listFits{num}.startPrePoints(handles.plotAxes);
        
        controlObj.seqObj{handles.number} = controlObj.seqObj{handles.number}.updateFits(num);
        controlObj.seqObj{handles.number}.updatePlot;
        controlObj.seqObj{handles.number}.updatePlotFits;
        controlObj.seqObj{handles.number}.updateFitResults;
    end
end


%*************************
% edit fit parameters
%*************************
function pb_fit_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listFits{num} = gui_fitting( controlObj.seqObj{handles.number}.listFits{num} );
    updateGUIFits(handles, num);
    
    controlObj.seqObj{handles.number} = controlObj.seqObj{handles.number}.updateFits(num);
    controlObj.seqObj{handles.number}.updatePlot;    
    controlObj.seqObj{handles.number}.updatePlotFits;    
    controlObj.seqObj{handles.number}.updateFitResults;
end

%*************************
% change active fits
%*************************
function pb_fitA_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listFits{num}.doFit = logical(get(hObject,'Value'));
    if controlObj.seqObj{handles.number}.listFits{num}.doFit
        controlObj.seqObj{handles.number} = controlObj.seqObj{handles.number}.updateFits(num);
    end
    controlObj.seqObj{handles.number}.updatePlot;    
    controlObj.seqObj{handles.number}.updatePlotFits;
    controlObj.seqObj{handles.number}.updateFitResults;
end

% clear fits
function pb_fitsC_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number} = controlObj.seqObj{handles.number}.clearFits(num);
    controlObj.seqObj{handles.number}.updatePlot;    
    controlObj.seqObj{handles.number}.updatePlotFits;     
    controlObj.seqObj{handles.number}.updateFitResults;    
    updateGUIFits(handles, num);    
end

function pb_fitshow_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listFits{num}.showFit = logical(get(hObject,'Value'));
    eval(['pb_fitA_Callback(',['handles.pb_fitA',num2str(num)],', eventdata, handles, num);']);
end
function pb_fitsAdopt_Callback(hObject, eventdata, handles, num)
global controlObj;
    controlObj.seqObj{handles.number}.listFits{num}.adoptPoints = logical(get(hObject,'Value'));
    eval(['pb_fitA_Callback(',['handles.pb_fitA',num2str(num)],', eventdata, handles, num);']);    
end




%*************************************************************************
%
% Callbacks for loading and saving
%
%*************************************************************************


function pb_load_Callback(hObject, eventdata, handles)
global controlObj;
    gui_control(handles.number);
    controlObj.seqObj{handles.number}.updatePlot;    
    controlObj.seqObj{handles.number}.updatePlotFits;
end

function pb_save_Callback(hObject, eventdata, handles)
global controlObj;
    controlObj = controlObj.makeFigure(handles.number);
end

function rb_network_Callback(hObject, eventdata, handles)
global networkObj;
    value = get(hObject,'value');
    if value
        networkObj.initUdp;
        networkObj.openUdp;
    else
        networkObj.closeUdp;
    end
end


