function  y = vsawtooth( t, t_all, t_up, offs, ampl, dt)
%SAWTOOTH calculates sawtooth function
% with parameters 
% y = vsawtooth( t, t_all, t_up, offs, ampl)
%
%      / \                 ^
%     /   \                |
%    /     \    --- offs   |
%   /       \              |  ampl  
%  /         \             |  
%        t_down             
% <-- t_all -->
% Elmar, 4.8.2007 

t_cut = mod(t-dt,t_all);
flag  = (t_cut>t_up);

y = ampl *(~flag .* t_cut/t_up + flag.*(t_all-t_cut)/abs(t_all-t_up) )+offs;
