function watchPrePoints(haxes,seqNumber,fitNumber,color)
global controlObj;


    tag = ['pre',num2str(fitNumber)];
    % delete old pre points stuff
    delete(findobj(allchild(haxes),'tag',tag));

    % scale axes?
    xFix ='auto';
    yFix ='auto';

    if controlObj.seqObj{seqNumber}.listFits{fitNumber}.adoptPoints
        controlObj.seqObj{seqNumber}.listFits{fitNumber} = controlObj.seqObj{seqNumber}.listFits{fitNumber}.last2PrePoints(haxes);
    end
    prePoints = controlObj.seqObj{seqNumber}.listFits{fitNumber}.prePoints;

    % init line for plotting
    col = min([0.999,0.999,0.999],color.*[1.4,1.4,1.4]);
    hPreLine = line(0,0,'hittest','off','tag',tag,'linestyle',':','color',color,'parent',haxes,'Visible','off','linewidth',0.1);

    % set hggroup objects for points
    for i=1:size(prePoints,1)
        hg(i) = hggroup('ButtonDownFcn',{@initPoints,i},'parent',haxes,'tag',tag,'Interruptible','off');
        hpoint(i) = line(prePoints(i,1),prePoints(i,2),'HitTest','off',...
            'marker','o','markersize',14,...
            'linewidth',3,...
            'linestyle',':',...
            'Parent',hg(i),...
            'markerfacecolor',min([0.999,0.999,0.999],color+[0.95,0.95,0.95]),...
            'markeredgecolor',min([0.999,0.999,0.999],color+[0.7,0.7,0.7]),...
            'tag',tag);
    end
    if ~isempty(prePoints)
        plotPrePoints;
    end
    
    % start the movement of point "number"
    function initPoints(src, event, num)
        xFix = xlim('mode');yFix = ylim('mode');
        xlim('manual');
        ylim('manual'); 
        set(gcf,'WindowButtonMotionFcn',{@dragPoint,num}, 'BusyAction','cancel');
        set(gcf,'WindowButtonUpFcn',    {@dropPoint,num} );        
    end

    % drag the point around
    function dragPoint(src, event, num)
        cpoint = get(gca,'CurrentPoint');
        pp = cpoint(1,1:2);
        set( hpoint(num),'XData',pp(1));
        set( hpoint(num),'YData',pp(2));        
    end

    % stop the dragging
    function dropPoint(src, event, num)
        
        % stop calls
        set(gcf,'WindowButtonMotionFcn','');
        set(gcf,'WindowButtonUpFcn','');
        
        % take point
        cpoint = get(haxes,'CurrentPoint');
        prePoints(num,:) = cpoint(1,1:2);

        % fix plot
        xlim(haxes, xFix);
        ylim(haxes, yFix); 
               
        controlObj.seqObj{seqNumber}.listFits{fitNumber}.prePoints = prePoints;
        plotPrePoints;        
    end

    function plotPrePoints
        dx = xlim(haxes);
        [xrange,yrange] = controlObj.seqObj{seqNumber}.listFits{fitNumber}.calcDataPoints(dx,prePoints);
        if ~isempty(hPreLine)
            set(hPreLine,'XData',xrange,'YData',yrange,'parent',haxes,'Visible','on');  
        end
    end

end
