classdef fitSplineLinear < fitClass
%FITSPLINE class for simple spline
%
% childclass of @fitClass
%
% Elmar, 5.4.2007

properties
    
    %***************************
    % fit properties
    %***************************
    fitName@char       = 'SplineLinear';  % internal name
    minPoints@double   = 3;         % minimum number of datapoints

end


methods

    %***************************
    % Init fitting stuff
    %***************************
    function obj = initFitting(obj)
    
        % init fit
        obj.fType    = fittype('linearinterp' );   
        obj.minPoints     = 3;
        obj.fitName       = 'SplineLinear';  % internal name        
        obj.doPreSetting  = false;
        obj.fOpts{1}    = fitoptions(obj.fType);
    end

    
    function obj = pre2StartPoints(obj)
    end
   
    %***************************
    % write output to strings
    %***************************
    function obj = createOutput(obj)
        % prob. ms used calc freq.
        obj.bigStr = {'',','\bf    Model: Linear Spline'};

        obj.smallStr = sprintf('---');
    end

    %***************************
    % plot fit
    %***************************
    function obj = plotFit(obj,haxes)
        if ~isempty( obj.fResult )
            dx = xlim(haxes);
            xrange = linspace(dx(1),dx(2),500);
            obj.handle = plot(haxes,xrange,obj.fResult(xrange), ...
                   'color',obj.plotColor,'linewidth',1.5);
        end
    end

end

end
