function initSequence(nScreens)
%INITSEQUENCE initiates the sequence program
%
% used to set path variables and load/initiate
% global variables
%
% Elmar, Innsbruck 31.03.07
global controlObj;


% number of screens if available
if nargin==0
    nScreens = 1;
end


% add paths
if ~isdeployed
    addpath './GUI';
    addpath './fitClasses';
    savedpath = '.\saved\';
    warning off MATLAB:declareGlobalBeforeUse
else
    savedpath = '.\saved\';
end

if exist([savedpath,'controlObj.mat'])
    load([savedpath,'controlObj.mat']);
else
    controlObj = controlClass(datestr(now,'dd.mm.yyyy'));
end
controlObj = controlObj.initObject;
controlObj = controlObj.initNetwork;
controlObj = controlObj.initGUI(nScreens);


end
